<ng-container *ngIf="{
          categories: categories$ | async,
          competitions: competitions$ | async,
          divisions: divisions$ | async,
          groups: groups$ | async,
          days: days$ | async,
          teams: teams$ | async,
          screenSize: screenSize$ | async } as vm">
  <app-page-form>
    <ng-container ngProjectAs="[page-form-content]">
      <h1>
        {{ 'admin.plateau.edit.seo.' + mode.toString().toLocaleLowerCase() + '.title' | translate }}
      </h1>
      <p>
        {{ 'admin.plateau.edit.seo.' + mode.toString().toLocaleLowerCase() + '.description' | translate }}
      </p>
      <form [formGroup]="formGroup"
            #form="ngForm" (ngSubmit)="formGroup.valid && save()">
        <mat-form-field>
          <mat-label>
            {{ 'admin.plateau.edit.form.category' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.category"
                            [updateDisable]="mode !== editModeEnum.UPDATE"
                            [control]="formGroup.controls.category">
            <mat-select formControlName="category"
                        (selectionChange)="categoryChange()">
              <mat-option *ngFor="let category of vm.categories?.items; trackBy: trackBySlug"
                          [value]="category.slug">
                {{ category.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.category.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.plateau.edit.form.competition' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.competition"
                            [updateDisable]="mode !== editModeEnum.UPDATE"
                            [control]="formGroup.controls.competition">
            <mat-select formControlName="competition"
                        (selectionChange)="competitionChange()">
              <mat-option *ngFor="let competition of vm.competitions?.items; trackBy: trackBySlug"
                          [value]="competition.slug">
                {{ competition.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.competition.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.plateau.edit.form.division' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.division"
                            [updateDisable]="mode !== editModeEnum.UPDATE"
                            [control]="formGroup.controls.division">
            <mat-select formControlName="division"
                        (selectionChange)="divisionChange()">
              <mat-option *ngFor="let division of vm.divisions?.items; trackBy: trackBySlug"
                          [value]="division.slug">
                {{ division.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.division.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.plateau.edit.form.group' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.group"
                            [updateDisable]="mode !== editModeEnum.UPDATE"
                            [control]="formGroup.controls.group">
            <mat-select formControlName="group" [compareWith]="compareBySlug"
                        (selectionChange)="groupChange()">
              <mat-option *ngFor="let group of vm.groups?.items; trackBy: trackBySlug"
                          [value]="group">
                {{ group.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.group.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.plateau.edit.form.day' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.day"
                            [updateDisable]="mode !== editModeEnum.UPDATE"
                            [control]="formGroup.controls.day">
            <mat-select formControlName="day" [compareWith]="compareBySlug">
              <mat-option *ngFor="let day of vm.days?.items; trackBy: trackBySlug"
                          [value]="day">
                {{ day.index }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.day.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.plateau.edit.form.date' | translate }}
          </mat-label>
          <mat-datetimepicker-toggle [for]="datetimePicker" matSuffix></mat-datetimepicker-toggle>
          <mat-datetimepicker #datetimePicker type="datetime" openOnFocus="true" timeInterval="5"></mat-datetimepicker>
          <input matInput formControlName="date"
                 [matDatetimepicker]="datetimePicker" required autocomplete="false">
          <mat-error *ngIf="formGroup.controls.date.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.plateau.edit.form.location' | translate }}
          </mat-label>
          <input matInput name="location" formControlName="location"/>
          <mat-error *ngIf="formGroup.controls.location.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.plateau.edit.form.teams.label' | translate }}
          </mat-label>
          <mat-select formControlName="teams" multiple [compareWith]="compareBySlug">
            <mat-select-trigger class="team">
              <ng-container *ngFor="let team of formGroup.getRawValue().teams; trackBy: trackBySlug">
                <figure *ngIf="'common.team.defaultPicture.url' | translate">
                  <img class="lazy-load"
                       [lazyLoad]="team.logoUrl || ('common.team.defaultPicture.url' | translate)"
                       [errorImage]="'common.team.defaultPicture.url' | translate"
                       [alt]="team.name" />
                  <figcaption>
                    {{ team | teamName:vm.screenSize }}
                    {{ team.index }}
                  </figcaption>
                </figure>
              </ng-container>
            </mat-select-trigger>
            <mat-option *ngFor="let team of vm.teams; trackBy: trackBySlug"
                        [value]="team" class="team">
              <figure *ngIf="'common.team.defaultPicture.url' | translate">
                <img class="lazy-load"
                     [lazyLoad]="team.logoUrl || ('common.team.defaultPicture.url' | translate)"
                     [errorImage]="'common.team.defaultPicture.url' | translate"
                     [alt]="team.name" />
                <figcaption>
                  {{ team | teamName:vm.screenSize }}
                  {{ team.index }}
                </figcaption>
              </figure>
            </mat-option>
          </mat-select>
          <mat-error *ngIf="formGroup.controls.teams.errors?.noAvailableTeam">
            {{ 'admin.plateau.edit.form.teams.noTeamAvailable' | translate }}
          </mat-error>
          <mat-error *ngIf="formGroup.controls.teams.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.plateau.edit.form.participant' | translate }}
          </mat-label>
          <mat-select formControlName="participant" [compareWith]="compareBySlug">
            <mat-select-trigger class="team">
              <figure *ngIf="('common.team.defaultPicture.url' | translate) && formGroup.controls.participant.value as participant">
                <img class="lazy-load"
                     [lazyLoad]="participant?.logoUrl || ('common.team.defaultPicture.url' | translate)"
                     [errorImage]="'common.team.defaultPicture.url' | translate"
                     [alt]="participant?.name" />
                <figcaption>
                  {{ participant | teamName:vm.screenSize }}
                </figcaption>
              </figure>
            </mat-select-trigger>
            <mat-option *ngFor="let participant of getParticipants(); trackBy: trackBySlug"
                        [value]="participant" class="team">
              <figure *ngIf="'common.team.defaultPicture.url' | translate">
                <img class="lazy-load"
                     [lazyLoad]="participant.logoUrl || ('common.team.defaultPicture.url' | translate)"
                     [errorImage]="'common.team.defaultPicture.url' | translate"
                     [alt]="participant.name" />
                <figcaption>
                  {{ participant | teamName:vm.screenSize }}
                </figcaption>
              </figure>
            </mat-option>
          </mat-select>
          <mat-error *ngIf="formGroup.controls.teams.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>
      </form>
    </ng-container>
    <ng-container ngProjectAs="[page-form-footer]">
      <a mat-stroked-button color="accent"
         [routerLink]="previousRouteCommands?.commands"
         [queryParams]="previousRouteCommands?.queryParams">
        <mat-icon>
          cancel
        </mat-icon>
        {{ 'admin.common.action.cancel' | translate }}
      </a>
      <app-async-button [loading]="loading.save">
        <button mat-flat-button color="primary" (click)="form.onSubmit($event)">
          <mat-icon>
            save
          </mat-icon>
          {{ 'admin.common.action.save' | translate }}
        </button>
      </app-async-button>
    </ng-container>
  </app-page-form>
</ng-container>
